/**
 * Copyright &copy; 2015-2020 <a href="http://www.jeeplus.org/">JeePlus</a> All rights reserved.
 */
package com.jeeplus.modules.sg.managementcenter.constructionProject.service;

import com.jeeplus.core.persistence.Page;
import com.jeeplus.core.service.CrudService;
import com.jeeplus.modules.sg.managementcenter.constructionProject.entity.ConstructionProject;
import com.jeeplus.modules.sg.managementcenter.constructionProject.mapper.ConstructionProjectMapper;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.util.List;


@Service
@Transactional(readOnly = true)
public class ConstructionProjectService extends CrudService<ConstructionProjectMapper, ConstructionProject> {

	@Autowired
	private ConstructionProjectMapper constructionProjectMapper;

	public ConstructionProject get(String id) {
		return super.get(id);
	}
	
	public List<ConstructionProject> findList(ConstructionProject constructionProject) {
		return super.findList(constructionProject);
	}

	public Page<ConstructionProject> findPage(Page<ConstructionProject> page, ConstructionProject constructionProject) {
		return super.findPage(page, constructionProject);
	}
	
	@Transactional(readOnly = false)
	public void save(ConstructionProject constructionProject) {
		super.save(constructionProject);
	}

	//文件导入
	@Transactional(readOnly = false)
	public void savaList(List<ConstructionProject> list){
		for (ConstructionProject constructionProject:list){
			constructionProject.preInsert();
		}
		constructionProjectMapper.insertList(list);
	}

}