/**
 * Copyright &copy; 2015-2020 <a href="http://www.jeeplus.org/">JeePlus</a> All rights reserved.
 */
package com.jeeplus.modules.sg.materialmodule.activiti.service;

import com.jeeplus.core.persistence.Page;
import com.jeeplus.core.service.CrudService;
import com.jeeplus.modules.sg.advence.activiti.entity.Advance;
import com.jeeplus.modules.sg.advence.activiti.mapper.AdvanceMapper;
import com.jeeplus.modules.sg.materialmodule.activiti.entity.MaterialModule;
import com.jeeplus.modules.sg.materialmodule.activiti.mapper.MaterialModuleMapper;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.util.Date;
import java.util.List;

/**
 * 请假表单Service
 * @author lgf
 * @version 2018-06-12
 */
@Service
@Transactional(readOnly = true)
public class MaterialModuleService extends CrudService<MaterialModuleMapper, MaterialModule> {
    @Autowired
	private MaterialModuleMapper materialModuleMapper;

	public MaterialModule get(String id) {
		MaterialModule materialModule = super.get(id);
		return materialModule;
	}

	//查询项目信息
	public String findProjectName (String procInsId){
		return materialModuleMapper.findProjectName(procInsId);
	}

	//根据项目名称查询，项目计划开工时间
	public Date findSpecificTime(String projectName){
		return materialModuleMapper.findSpecificTime(projectName);
	}

	//根据角色名查找用户id
	public List<String> findUserId(List<String> list){
		return materialModuleMapper.findUserId(list);
	}

	@Transactional(readOnly = false)
	@Override
	public void save(MaterialModule entity) {
		materialModuleMapper.updateConstructionStatus(entity);
		super.save(entity);
	}
}