package com.jeeplus.modules.sg.materialmodule.activiti.web;

import com.google.common.collect.Maps;
import com.jeeplus.common.json.AjaxJson;
import com.jeeplus.common.utils.DateUtils;
import com.jeeplus.common.utils.StringUtils;
import com.jeeplus.common.utils.excel.ExportExcel;
import com.jeeplus.core.persistence.Page;
import com.jeeplus.core.web.BaseController;
import com.jeeplus.modules.act.service.ActProcessService;
import com.jeeplus.modules.act.service.ActTaskService;
import com.jeeplus.modules.sg.managementcenter.activiti.service.ConstructionService;
import com.jeeplus.modules.sg.managementcenter.activiti.utils.MyActiviUtils;
import com.jeeplus.modules.sg.managementcenter.materialInventory.entity.MaterialInventory;
import com.jeeplus.modules.sg.managementcenter.materialProvided.entity.MaterialProvided;
import com.jeeplus.modules.sg.managementcenter.materialProvided.service.MaterialProvidedService;
import com.jeeplus.modules.sg.managementcenter.project.entity.Project;
import com.jeeplus.modules.sg.managementcenter.project.service.ProjectService;
import com.jeeplus.modules.sg.materialmodule.activiti.entity.MaterialModule;
import com.jeeplus.modules.sg.materialmodule.activiti.service.MaterialModuleService;
import com.jeeplus.modules.sg.picking.activiti.entity.*;
import com.jeeplus.modules.sg.picking.activiti.service.PickIngService;
import com.jeeplus.modules.sg.picking.activiti.service.ShowListService;
import com.jeeplus.modules.sys.entity.DictValue;
import com.jeeplus.modules.sys.utils.UserUtils;
import org.activiti.engine.repository.ProcessDefinition;
import org.apache.shiro.authz.annotation.RequiresPermissions;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.ui.Model;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.ResponseBody;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.io.IOException;
import java.io.UnsupportedEncodingException;
import java.math.BigDecimal;
import java.net.URLDecoder;
import java.util.*;

@Controller
@RequestMapping(value = "${adminPath}/materialmodule/activiti")
public class MaterialModuleController extends BaseController {
    @Autowired
    private MaterialModuleService materialModuleService;
    @Autowired
    private ActProcessService actProcessService;
    @Autowired
    private ActTaskService actTaskService;

    /**
     * 施工模块发起页面
     */
    @RequestMapping(value = "materialModuleForm")
    public String materialModuleForm(MaterialModule materialModule, Model model) {
        model.addAttribute("materialModule", materialModule);
        return "modules/sg/materialmodule/activiti/materialModuleForm";
    }

    /**
     * 非涉电开工流程
     */
    @RequestMapping(value = "nonPowerStart")
    public String nonPowerStart(MaterialModule materialModule, Model model) {
        MaterialModule materialShow = materialModuleService.get(materialModule.getAct().getProcInsId());
        model.addAttribute("materialShow", materialShow);
        model.addAttribute("materialModule", materialModule);
        return "modules/sg/materialmodule/activiti/nonPowerStart";
    }

    /**
     * 非涉电施工中流程
     */
    @RequestMapping(value = "nonPowerMiddle")
    public String nonPowerMiddle(MaterialModule materialModule, Model model) {
        MaterialModule materialShow = materialModuleService.get(materialModule.getAct().getProcInsId());
        model.addAttribute("materialShow", materialShow);
        model.addAttribute("materialModule", materialModule);
        return "modules/sg/materialmodule/activiti/nonPowerMiddle";
    }

    /**
     * 非涉电竣工流程
     */
    @RequestMapping(value = "nonPowerEnd")
    public String nonPowerEnd(MaterialModule materialModule, Model model) {
        MaterialModule materialShow = materialModuleService.get(materialModule.getAct().getProcInsId());
        model.addAttribute("materialShow", materialShow);
        model.addAttribute("materialModule", materialModule);
        return "modules/sg/materialmodule/activiti/nonPowerEnd";
    }

    /**
     * 是否完成非涉电工作
     */
    @RequestMapping(value = "nonPowerWhether")
    public String nonPowerWhether(MaterialModule materialModule, Model model) {
        MaterialModule materialShow = materialModuleService.get(materialModule.getAct().getProcInsId());
        model.addAttribute("materialShow", materialShow);
        model.addAttribute("materialModule", materialModule);
        return "modules/sg/materialmodule/activiti/nonPowerWhether";
    }

    /**
     * 涉电开工流程
     */
    @RequestMapping(value = "PowerStart")
    public String PowerStart(MaterialModule materialModule, Model model) {
        MaterialModule materialShow = materialModuleService.get(materialModule.getAct().getProcInsId());
        model.addAttribute("materialShow", materialShow);
        model.addAttribute("materialModule", materialModule);
        return "modules/sg/materialmodule/activiti/PowerStart";
    }

    /**
     * 涉电竣工流程
     */
    @RequestMapping(value = "PowerEnd")
    public String PowerEnd(MaterialModule materialModule, Model model) {
        MaterialModule materialShow = materialModuleService.get(materialModule.getAct().getProcInsId());
        model.addAttribute("materialShow", materialShow);
        model.addAttribute("materialModule", materialModule);
        return "modules/sg/materialmodule/activiti/PowerEnd";
    }

    /**
     * 是否完成所有涉电工作
     */
    @RequestMapping(value = "PowerWhether")
    public String PowerWhether(MaterialModule materialModule, Model model) {
        MaterialModule materialShow = materialModuleService.get(materialModule.getAct().getProcInsId());
        model.addAttribute("materialShow", materialShow);
        model.addAttribute("materialModule", materialModule);
        return "modules/sg/materialmodule/activiti/PowerWhether";
    }

    /**
     * 施工单位项目经理判断项目是否包含涉电工作
     */
    @RequestMapping(value = "managerWhether")
    public String managerWhether(MaterialModule materialModule, Model model) {
        MaterialModule materialShow = materialModuleService.get(materialModule.getAct().getProcInsId());
        model.addAttribute("materialShow", materialShow);
        model.addAttribute("materialModule", materialModule);
        return "modules/sg/materialmodule/activiti/managerWhether";
    }


    /**
     * 施工流程发起
     */
    @ResponseBody
    @RequestMapping(value = "containSave")
    public AjaxJson save(MaterialModule materialModule, Model model,String procDefId,String flag) throws Exception {
        AjaxJson j = new AjaxJson();
        /**
         * 后台hibernate-validation插件校验
         */
        String errMsg = beanValidator(materialModule);
        if (StringUtils.isNotBlank(errMsg)) {
            j.setSuccess(false);
            j.setMsg(errMsg);
            return j;
        }
        String projectId = materialModule.getProjectId();
        if (projectId == null||"".equals(projectId)) {
            j.setSuccess(false);
            j.setMsg("请选择项目");
            return j;
        }
        /**
         * 流程审批
         */
        if (StringUtils.isBlank(materialModule.getId())) {
            //保存
            //修改项目的施工模块状态
            materialModule.setUserName(UserUtils.getUser().getLoginName());
            materialModuleService.save(materialModule);
            // 启动流程
            Map<String, Object> vars = Maps.newHashMap();
            Project userById = MyActiviUtils.findUserById(projectId);
            vars.put("manager", userById.getConstructionUnitManage());
            if ("contain".equals(flag)) {
                vars.put("contain", true);
                vars.put("notContain", false);
                vars.put("no", false);
            } else if ("notContain".equals(flag)) {
                vars.put("contain", false);
                vars.put("notContain", true);
                vars.put("no", false);
            } else {
                vars.put("contain", false);
                vars.put("notContain", false);
                vars.put("no", true);
            }
            ProcessDefinition p = actProcessService.getProcessDefinition(procDefId);
            String title = materialModule.getCurrentUser().getName() + "在" + DateUtils.getDateTime() + "发起" + p.getName();
            actTaskService.startProcess(p.getKey(), "sg_construction_process", materialModule.getId(), title, vars);
            j.setMsg("发起施工流程成功!");
            j.getBody().put("targetUrl", "/act/task/process/");
        }
        return j;
    }
}


